package com.ashokit.ticketbooking;

import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import com.ashokit.ticketbooking.model.Ticket;
import com.ashokit.ticketbooking.service.TicketService;

@SpringBootApplication
public class TicketBookingApplication implements CommandLineRunner {
	
	@Autowired
	private TicketService ticketService;

	public static void main(String[] args) {
		SpringApplication.run(TicketBookingApplication.class, args);
	}

	@Override
	public void run(String... args) throws Exception {
		
		
		//The code what ever you write here will  be executed only once by the framework
		//Generally we will use for static data population
		
		
	// We will create a ticket as part of this.
		
		Ticket sampleTicket=new Ticket();
		sampleTicket.setPassengerName("RAMU");
		sampleTicket.setSourceStation("HYDERABAD");
		sampleTicket.setDestinationStation("GOA");
		sampleTicket.setEmail("ramu@gmail.com");
		sampleTicket.setTravelDate(new Date());
		
		
		ticketService.createTicket(sampleTicket);
		
		
		
	}

}
