package com.ashokit.ticketbooking.dao;

import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import com.ashokit.ticketbooking.model.Ticket;

/*
 * 
 * DAO ==> Data Access Object With TicketDao we can perform all database operations.
 * @Repository==> For Performing database operations ==> Database connection is required.
 * 				  Spring Boot automatically makes a database connection while running the application 
 *                      JDBC ==> Connection
 *                      HIbernate ==> Session Factory
 *                      DATA JPA ==> EntityManager Factory
 *                      
 *                      
 *                      
 *    Every Table common operations ==> CRUD 
 *                                  ==> C ==> Create ==> Insert into tbl_ticket values(....);
 *                                  ==> R ==> Read   ==> select * from tbl_ticket
 *                                  			     ==> select * from tbl_ticket where ..
 *                                  ==> U ==> Update ==> update tbl_ticket set........
 *                                  ==> D ==> Delete ==> delete tbl_ticket where ...?
 *                                 
 *    
 *    Framework created CRUDRepository for Peforming CRUD Operations
 *                Two   Inputs ==> 1) ClassName  2) DataType of the Primary key
 */   


@Repository
public interface TicketDao extends CrudRepository<Ticket, Integer> {
	
	
	
	/*
	 * 
	 *  ticketDao.save ==> insert / update the data
	 *  ticketDao.findAll ==> Retrieve all records
	 *  ticketDao.findById ==> Retrieve specific Record
	 *  ticketDao.deleteById ==> Delete specific record
	 *  
	 */

}
