package com.ashokit.ticketbooking.model;

import java.util.Date;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.Table;

@Entity
// @Entity ==> This is going to create table with class name as table name
@Table(name = "tbl_ticket")
// Its optional Annotation which is used for customizing the table name ===> it will create table with tbl_ticket
public class Ticket {
	
	
	//From JPA Point of view every table should have primary key
	
	@Id //This Annotation will create a primary key for ticket_id column
	@GeneratedValue(strategy = GenerationType.AUTO) // This value populated by JPA itself
	@Column(name = "ticket_id")
	private Integer ticketId;

	
	@Column(name="passenger_name")
	private String passengerName;
	//Every class level member ==> Database column
	//By default column name will be property name
	//@Column ==> customizes the column name
	
	@Column(name="source_station")
	private String sourceStation;
	
	
	@Column(name="destination_station")
	private String destinationStation;
	
	
	@Column(name="travel_date")
	private Date travelDate;
	
	
	private String email;


	public Integer getTicketId() {
		return ticketId;
	}


	public void setTicketId(Integer ticketId) {
		this.ticketId = ticketId;
	}


	public String getPassengerName() {
		return passengerName;
	}


	public void setPassengerName(String passengerName) {
		this.passengerName = passengerName;
	}


	public String getSourceStation() {
		return sourceStation;
	}


	public void setSourceStation(String sourceStation) {
		this.sourceStation = sourceStation;
	}


	public String getDestinationStation() {
		return destinationStation;
	}


	public void setDestinationStation(String destinationStation) {
		this.destinationStation = destinationStation;
	}


	public Date getTravelDate() {
		return travelDate;
	}


	public void setTravelDate(Date travelDate) {
		this.travelDate = travelDate;
	}


	public String getEmail() {
		return email;
	}


	public void setEmail(String email) {
		this.email = email;
	}


	public Ticket(String passengerName, String sourceStation, String destinationStation, 
			String email) {
		super();
		this.passengerName = passengerName;
		this.sourceStation = sourceStation;
		this.destinationStation = destinationStation;
		this.travelDate = new Date();
		this.email = email;
	}
	
	
	
	public Ticket() {}


	@Override
	public String toString() {
		return "Ticket [ticketId=" + ticketId + ", passengerName=" + passengerName + ", sourceStation=" + sourceStation
				+ ", destinationStation=" + destinationStation + ", travelDate=" + travelDate + ", email=" + email
				+ "]";
	}
	
	
	
	
}
