package com.ashokit.ticketbooking.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ashokit.ticketbooking.dao.TicketDao;
import com.ashokit.ticketbooking.model.Ticket;

@Service

//@Service ==>  It will create service level boundary like transaction mangment, logging, rest api calling  etc..
public class TicketService {
	
	
	@Autowired
	private TicketDao ticketDao; ///TicketDao ticketDao=ioc.getTicketDao();
	
	
	//Create Ticket
	
	public Ticket createTicket(Ticket inputObj) {
		return ticketDao.save(inputObj);
		
		//save ==> insert into tbl_ticket values (inputObj.getPssengeName,inputObj.getSource,inputObj.getDest,inputObj.travelDate);
	}
	
	
	
	//Retrieve All Tickets
	public Iterable<Ticket> getAllTickets(){
		return ticketDao.findAll();
		
		//findAll ==> select * from tbl_ticket;
		//Converting Resultset into Iterable<Ticket> done by Framwork 
	}
	
	
	
	//Retrieve Single Ticket
	
	
	public Ticket getTicket(Integer ticketId) {
		return ticketDao.findById(ticketId).
								orElse(new Ticket());
		
		//ticketService.getTicket(100) ==> Avaiable in db ==> ticket.getPassengerName ==> No NULL POINTER EXCEPTION
		//ticketService.getTicket(10) ==> NOt Avaiable in db ==> ticket.getPassengerName ==> NULL POINTER EXCEPTION
		//orElse  will be invoked when data is not available in db
	}
	
	
	//Update Ticket
	public Ticket updateTicket(Integer ticketId,String newEmail) {
		//1,vijay@gmail.com ==> update tbl_ticket set email=vijay@gmail.com where ticket_id=1
		Ticket dbObj=getTicket(ticketId); //select * from tbl_ticket where ticket_id=1;
		dbObj.setEmail(newEmail);
		return ticketDao.save(dbObj);
		
		
		/*
		 *  
		 * save is the method will create or update based on the input object primary key value
		 *  if inputobj ==> PK VALUES(ticket_id) if we are not setting then save method will  ==> insert
		 *  if inputobj ==> PK value ==> some value is there ==> but not available in the database ==> insert
		 *  if inputobj ==> PK value ==> some value is there ==> but  available in the database ==> update
		 *  
		 */
		
	}
	
	
	
	
	//Delete Ticket
	
	public void deleteTicket(Integer ticketId) {
		ticketDao.deleteById(ticketId);
		//deleteById ==> delete tbl_ticket where ticket_id=ticketId
	}

}
